
//   !hpf$ processors p(3, 2)
// 
//   !hpf$ template t(30, 30)
//   !hpf$ distribute t(block, block) onto p
// 
//   integer a(5, 6)
//   !hpf$ align a(i, j) with t(6 * i, 5 * j)
// 
//   integer i, j
// 
//   do i = 1, 5
//     do j = 1, 6
//       a(i, j) = 10 * i + j
//     enddo
//   enddo
// 
//   do i = 1, 5
//     print "(10i4)", a(i, : )
//   enddo
// 
//   print *
// 
//   a = cshift(a, 2, 1)
//   
//   do i = 1, 5
//     print "(10i4)", a(i, : )
//   enddo
// 
//   print *
// 
//   a = cshift(a, 2, 2)
//   
//   do i = 1, 5
//     print "(10i4)", a(i, : )
//   enddo
// end


#include <stdio.h>
#include "ad++.h"
#include "admacros.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  Procs2 p(3, 2) ;

  //Range t1(30, p.dim(0), BLK) ;
  BlockRange t1(30, p.dim(0)) ;
  //Range t2(30, p.dim(1), BLK) ;
  BlockRange t2(30, p.dim(1)) ;

  Range x = t1.subrng(5, 5, 6) ;
  Range y = t2.subrng(6, 4, 5) ;

  Array2<int> a(x, y, p), result(x, y, p) ;

  ON(p) {
    Index i(x), j(y) ;
    WHERE(i) {
      WHERE(j) {
	a(i, j) = 10 * (i + 1) + j + 1 ;
      } EREWH(j) ;
    } EREWH(i) ;
  } NO(p) ;

  aprintf("%4d%*N", a, y.size()) ;
  gprintf("\n") ;

  shift(result, a, 2, 0, CYCL) ;
  copy(a, result) ;
  
  aprintf("%4d%*N", a, y.size()) ;
  gprintf("\n") ;

  shift(result, a, 2, 1, CYCL) ;
  copy(a, result) ;
  
  aprintf("%4d%*N", a, y.size()) ;

  } AdlibFinalize() ;
}


